<id>
ChatBox - YaBB 2.6.1
</id>

<version>
1.3
</version>

<mod info>
This mod adds a Chat Box with wysiwyg editor to your 2.6.1 Forum.
Besides a "General Chat" room it uses the existing Board names as Chat room names.
It'll show a list of participants for every Chat room.
Participants can start/stop Chat auto-update.

Admin can:
- Enable / disable Chat
- Enable Chat Button on Message Index
- Enable / disable alert before deleting a Chat message
- Exclude Board names not wanted as Chat rooms
- Set max. number of characters in a Chat message
- Set the number of minutes Chat messages stay alive
- Set the number of minutes inactive participants stay in the Chat log
- Set Chat/participants update rate in seconds

Before you apply this mod you must download the Variables/Settings.pm file to the Variables folder in your BoardMod folder structure.

Apply this mod.

Upload (in ASCII mode):
cgi-bin/yabb2/Admin/ModList.pm
cgi-bin/yabb2/Admin/NewSettings.pm
cgi-bin/yabb2/Admin/Settings_Main.pm

cgi-bin/yabb2/Languages/English/Menu.lng

cgi-bin/yabb2/Sources/AdvancedTabs.pm
cgi-bin/yabb2/Sources/MessageIndex.pm
cgi-bin/yabb2/Sources/Subs.pm
cgi-bin/yabb2/Sources/SubList.pm
cgi-bin/yabb2/Sources/TabMenu.pm

cgi-bin/yabb2/Templates/default/MessageIndex.template
cgi-bin/yabb2/Templates/default/Menu.def

cgi-bin/yabb2/Variables/Settings.pm

public_html/yabbfiles/Templates/Forum/default.css


From the zip package upload (in ASCII mode):

cgi-bin/yabb2/Languages/English/ChatBox.lng
cgi-bin/yabb2/Sources/Mods/ChatBox.pm

and (in binary mode):
public_html/yabbfiles/ModImages/chat1.png
public_html/yabbfiles/ModImages/chatce/*.*


Go to "Admin Center - Forum Settings - Chat" and check "Enable Chat".

The "Chat" tab is positioned as the last tab in the menu. You can use "Edit tabs" to push it to another position.

</mod info>

<author>
Carsten (updated for 2.6.1 by Dandello)
</author>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $chatbox = "ChatBox|Carsten (updated for 2.6.1 by Dandello)|This mod adds a chat box.|1.3|10/14/14";
    push  @installed_mods, $chatbox;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
###############################################################################
# Advanced Settings                                                           #
###############################################################################
</search for>

<add before>
########## Chat configuration ##########

\$enablechat = $enablechat;             # Set to 1 to enable Chat CE
\$mibutton = $mibutton;                 # Set to 1 to show Chat Button in Message Index
\$removealert = $removealert;               # Set to 1 to show alert before removing a chat comment
\$MaxChatLen = $MaxChatLen;             # Max. characters in a chat message.
\$message_term = $message_term;             # Number of minutes a chat message will stay alive.
\$part_term = $part_term;                   # Number of minutes a inactive participant will stay in the chat log.
\$update_freq = $update_freq;                   # Update frequency in seconds.
\$ChatRoom = "\Q$ChatRoom\E";               # Board names to exclude as Chat Room names.

</add before>


<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
LoadLanguage('Register');
</search for>

<add after>
LoadLanguage('ChatBox');
</add after>

<search for>
# Date/Time selector
</search for>

<add before>
# Chat room selector
get_forum_master;
my $catoptions;
for my $catid (@categoryorder) {
    my ($catname, undef, undef, undef) = split /\|/xsm, $catinfo{$catid};
    ToChars($catname);
    @sellist = split /\, /sm, $ChatRoom;
    $testcatid = $catid . '_cat';
    $catbdselected = q{};
    for (@sellist) {
        if($_ eq $testcatid) { $catbdselected = qq~ selected="selected"~; }
    }
    $catoptions .= qq~<option value="$testcatid" style="color: #000000; background-color: #FFFEDF; border-bottom: 1px dotted #D6B2FF; border-top: 1px dotted #D6B2FF;"$catbdselected>$catname</option>\n~;
    $boardlist = $cat{$catid};
    @bdlist = split /\,/xsm, $boardlist;
    for my $curboard (@bdlist) {
        $bdselected = q{};
        my ($boardname, undef, undef) = split /\|/xsm, $board{$curboard};
        for (@sellist) {
            if($_ eq $curboard || $catbdselected ne q{}) { $bdselected = q~ selected="selected"~; }
        }
        $catoptions .= qq~<option value="$curboard"$bdselected>&nbsp; $boardname</option>\n~;
        if ( $subboard{$curboard} ) {
            $sublist = $subboard{$curboard};
            @bdsublist = split /\|/xsm, $sublist;
            for my $sbcurboard (@bdsublist) {
                $bdsubselected = q{};
                my ($subboardname, undef, undef) = split /\|/xsm, $board{$sbcurboard};
                for (@sellist) {
                    if($_ eq $sbcurboard || $catbdselected ne q{}) { $bdsubselected = q~ selected="selected"~; }
                }
                $catoptions .= qq~<option value="$sbcurboard"$bdsubselected>&nbsp; &nbsp;-$subboardname</option>\n~;
            }
        }
    }
}

if ( !$message_term ) { $message_term = 120; }
if ( !$part_term ) { $part_term = 15; }
if ( !$update_freq ) { $update_freq = 10; }
if ( !$MaxChatLen ) { $MaxChatLen = 300; }
</add before>

<search for>
            depends_on => ['enable_MCaway!=0', 'PM_level!=0'],
        },
    ],
},
</search for>

<add after>
{
    name  => $chatce_txt{'chatbox'},
    id    => 'chatce',
    items => [
        {
            header => $chatce_txt{'showhide'},
        },
        {
            description => $chatce_txt{'enablechat'},
            input_html => qq~<input type="checkbox" name="enablechat" value="1"${ischecked($enablechat)} />~,
            name => 'enablechat',
            validate => 'boolean',
        },
        {
            description => $chatce_txt{'mibutton'},
            input_html => qq~<input type="checkbox" name="mibutton" value="1"${ischecked($mibutton)} />~,
            name => 'mibutton',
            validate => 'boolean',
        },
        {
            description => $chatce_txt{'remalert'},
            input_html => qq~<input type="checkbox" name="removealert" value="1"${ischecked($removealert)} />~,
            name => 'removealert',
            validate => 'boolean',
        },
        {
            description => $chatce_txt{'boardexcl'},
            input_html => qq~<select multiple="multiple" name="ChatRoom" size="8">$catoptions</select>~,
            name => 'ChatRoom',
            validate => 'text,null',
        },
        {
            header => $chatce_txt{'timers'},
        },
        {
            description => $chatce_txt{'maxchar'},
            input_html => qq~<input type="text" maxlength="4" size="3" name="MaxChatLen" value="$MaxChatLen" />~,
            name => 'MaxChatLen',
            validate => 'number,null',
        },
        {
            description => $chatce_txt{'messageterm'},
            input_html => qq~<input type="text" maxlength="4" size="3" name="message_term" value="$message_term" />~,
            name => 'message_term',
            validate => 'number,null',
        },
        {
            description => $chatce_txt{'partterm'},
            input_html => qq~<input type="text" maxlength="4" size="3" name="part_term" value="$part_term" />~,
            name => 'part_term',
            validate => 'number,null',
        },
        {
            description => $chatce_txt{'updatefrq'},
            input_html => qq~<input type="text" maxlength="4" size="3" name="update_freq" value="$update_freq" />~,
            name => 'update_freq',
            validate => 'number,null',
        },
    ],
},
</add after>

<edit file>
Languages/English/Menu.lng
</edit file>

<search for>
require Sources::Menu;
</search for>

<add before>
$img_txt{'chatce'} = 'Chat';

</add before>

<edit file>
Sources/AdvancedTabs.pm
</edit file>

<search for>

    GetTexttab();
</search for>

<add before>
    $edittab{'chatce'} = qq~<span $tabstyle>$tabfill$img_txt{'chatce'}$tabfill</span>~;
</add before>

<search for>

    if ( !$tab_lang ) { GetTabtxt(); }
</search for>

<add before>
    $texttab{'chatce'} = $img_txt{'chatce'};
</add before>

<edit file>
Sources/MessageIndex.pm
</edit file>

<search for>
    if ( AccessCheck( $currentboard, 3 ) eq 'granted' ) {
        $polllink =
qq~$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=CreatePoll">$img{'createpoll'}</a>~;
    }
</search for>

<add after>
    $chatcelink = q{};
    if(!$iamguest && $mibutton) {
        (@excllist) = split /\, /sm, $ChatRoom;
        $testcatid = $catid . '_cat';
        $useboard = 1;
        foreach (@excllist) {
            if ($_ eq $currentboard || $_ eq $testcatid) { $useboard = 0; }
        }
        if($useboard) {
            $chatcelink = qq~$menusep<a href="$scripturl?action=chat;room=$currentboard">$img{'chatce'}</a>~;
        }
    }
</add after>

<search for>
    $outside_threadtools =~
      s/{yabb new poll button}/$threadout[3]/gsm;
</search for>

<add after>
    $outside_threadtools =~ s/{yabb chatce button}/$chatcelink/gsm;
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
1;
</search for>

<add before>
## ChatBox Mod ##
$director{'chat'} = 'ChatBox.pm&chatCE';
$director{'cdchatopen'} = 'ChatBox.pm&chatCE_open';
$director{'cdchatupdate'} = 'ChatBox.pm&chatCE_open';
$director{'cdupdatechat'} = 'ChatBox.pm&UpdateChat';
$director{'cdupdatepart'} = 'ChatBox.pm&UpdateParticipants';
$director{'createlink'} = 'ChatBox.pm&InsertLink';
$director{'cdchatpalette'} = 'ChatBox.pm&ColorPicker';

</add before>

<edit file>
Sources/TabMenu.pm
</edit file>

<search for>
    if ( $action eq 'addtab' && $iamadmin ) {
</search for>

<add before>
    push @{ $acting[0] }, 'chat';
    push @{ $acting[1] }, 'chatce';
## Mod hook 1 ##

</add before>

<search for>
        foreach my $i ( 0 .. 28 ) {
</search for>

<replace>
        foreach my $i ( 0 .. $#{$acting[0]} ) {
</replace>

<search for>
    $yytabmenu = qq~                   <ul>\n~;
</search for>

<add before>
    if (!$iamguest && $enablechat) {
        $tab{'chatce'} = qq~<span |><a href="$scripturl?action=chat" title = "$img_txt{'chatce'}" style="padding: 3px 0 4px 0;">$tabfill$img_txt{'chatce'}$tabfill</a></span>~;
    }
</add before>


<edit file>
Templates/default/MessageIndex.template
</edit file>

<search for>
$outside_threadtools = qq~{yabb new post button}{yabb new poll button}~;
</search for>

<replace>
$outside_threadtools = qq~{yabb new post button}{yabb new poll button}{yabb chatce button}~;
</replace>

<edit file>
Templates/default/Menu.def
</edit file>

<search for>
youtube,youtube|img_txt|youtube|||imgwindowbg|gif|tmp
</search for>

<add after>
chatce,chat1|img_txt|chatce|||imgcatbg|gif|mod
</add after>


<edit file>
Variables/Settings.pm
</edit file>

<search for>
1;
</search for>

<add before>
push @AdvancedTabs, 'chatce';
</add before>

<edit file>
../../public_html/yabbfiles/Templates/Forum/default.css
</edit file>

<search for>
.mar-bot { margin-bottom: 1em;}
</search for>

<add after>
.deftpalchat {
    border: 0;
    cursor: pointer;
    float: left;
    font-size: 5px;
    height: 15px;
    margin-bottom: 1px;
    margin-right: 1px;
    width: 15px;
}
</add after>